        LIST
; 16F876 Register definitions.inc - Modified PIC16F876 header file
        NOLIST
        IFNDEF __16F876
           MESSG "Processor-header file mismatch.  Verify selected processor."
        ENDIF
;==========================================================================
;       RAM Definition
;==========================================================================
        __MAXRAM H'1FF'
	__BADRAM H'08'-H'09'
        __BADRAM H'88'-H'89', H'8F'-H'90', H'95'-H'97', H'9A'-H'9D'
        __BADRAM H'105', H'107'-H'109'
        __BADRAM H'185', H'187'-H'189', H'18E'-H'18F'
;==========================================================================
;       Configuration Bits
;==========================================================================
_CP_ALL                      EQU     H'0FCF'
_CP_HALF                     EQU     H'1FDF'
_CP_UPPER_256                EQU     H'2FEF'
_CP_OFF                      EQU     H'3FFF'
_DEBUG_ON                    EQU     H'37FF'
_DEBUG_OFF                   EQU     H'3FFF'
_WRT_ENABLE_ON               EQU     H'3FFF'
_WRT_ENABLE_OFF              EQU     H'3DFF'
_CPD_ON                      EQU     H'3EFF'
_CPD_OFF                     EQU     H'3FFF'
_LVP_ON                      EQU     H'3FFF'
_LVP_OFF                     EQU     H'3F7F'
_BODEN_ON                    EQU     H'3FFF'
_BODEN_OFF                   EQU     H'3FBF'
_PWRTE_OFF                   EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'
;==========================================================================
;       Register Definitions
;==========================================================================
W                            EQU     H'0000'
F                            EQU     H'0001'
;----- Register Files------------------------------------------------------
INDF                         EQU     H'0000'
TMR0                         EQU     H'0001'
PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
PORTC                        EQU     H'0007'
PCLATH                       EQU     H'000A'
INTCON                       EQU     H'000B'
PIR1                         EQU     H'000C'
PIR2                         EQU     H'000D'
TMR1L                        EQU     H'000E'
TMR1H                        EQU     H'000F'
T1CON                        EQU     H'0010'
TMR2                         EQU     H'0011'
T2CON                        EQU     H'0012'
SSPBUF                       EQU     H'0013'
SSPCON                       EQU     H'0014'
CCPR1L                       EQU     H'0015'
CCPR1H                       EQU     H'0016'
CCP1CON                      EQU     H'0017'
RCSTA                        EQU     H'0018'
TXREG                        EQU     H'0019'
RCREG                        EQU     H'001A'
CCPR2L                       EQU     H'001B'
CCPR2H                       EQU     H'001C'
CCP2CON                      EQU     H'001D'
ADRESH                       EQU     H'001E'
ADCON0                       EQU     H'001F'
OPTION_REG                   EQU     H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
TRISC                        EQU     H'0087'
PIE1                         EQU     H'008C'
PIE2                         EQU     H'008D'
PCON                         EQU     H'008E'
SSPCON2                      EQU     H'0091'
PR2                          EQU     H'0092'
SSPADD                       EQU     H'0093'
SSPSTAT                      EQU     H'0094'
TXSTA                        EQU     H'0098'
SPBRG                        EQU     H'0099'
ADRESL                       EQU     H'009E'
ADCON1                       EQU     H'009F'
EEDATA                       EQU     H'010C'
EEADR                        EQU     H'010D'
EEDATH                       EQU     H'010E'
EEADRH                       EQU     H'010F'
EECON1                       EQU     H'018C'
EECON2                       EQU     H'018D'
;----- STATUS Bits --------------------------------------------------------
#define	IRP	STATUS,7
#define RP1	STATUS,6
#define RP0	STATUS,5
#define NOT_TO	STATUS,4
#define NOT_PD	STATUS,3
#define Z	STATUS,2
#define	DC	STATUS,1
#define	C	STATUS,0
;----- INTCON Bits --------------------------------------------------------
#define	GIE	INTCON,7
#define	PEIE	INTCON,6
#define	T0IE	INTCON,5
#define	INTE	INTCON,4
#define	RBIE	INTCON,3
#define	T0IF	INTCON,2
#define	INTF	INTCON,1
#define	RBIF	INTCON,0
;----- PIR1 Bits ----------------------------------------------------------
#define	ADIF	PIR1,6
#define	RCIF	PIR1,5
#define	TXIF	PIR1,4
#define	SSPIF	PIR1,3
#define	CCP1IF	PIR1,2
#define	TMR2IF	PIR1,1
#define	TMR1IF	PIR1,0
;----- PIR2 Bits ----------------------------------------------------------
#define	EEIF	PIR2,4
#define	BCLIF	PIR2,3
#define	CCP2IF	PIR2,0
;----- T1CON Bits ---------------------------------------------------------
#define	T1CKPS1	T1CON,5
#define	T1CKPS0	T1CON,4
#define	T1OSCEN	T1CON,3
#define	T1SYNC	T1CON,2
#define	TMR1CS	T1CON,1
#define	TMR1ON	T1CON,0
;----- T2CON Bits ---------------------------------------------------------
#define	TOUTPS3	T2CON,6
#define	TOUTPS2	T2CON,5
#define	TOUTPS1	T2CON,4
#define	TOUTPS0	T2CON,3
#define	TMR2ON	T2CON,2
#define	T2CKPS1	T2CON,1
#define	T2CKPS0	T2CON,0
;----- SSPCON Bits --------------------------------------------------------
;----- CCP1CON Bits -------------------------------------------------------
#define	CCP1X	CCP1CON,5
#define	CCP1Y	CCP1CON,4
#define	CCP1M3	CCP1CON,3
#define	CCP1M2	CCP1CON,2
#define	CCP1M1	CCP1CON,1
#define	CCP1M0	CCP1CON,0
;----- RCSTA Bits ---------------------------------------------------------
#define	SPEN	RCSTA,7
#define	RX9	RCSTA,6
#define	SREN	RCSTA,5
#define	CREN	RCSTA,4
#define	ADDEN	RCSTA,3
#define	FERR	RCSTA,2
#define OERR	RCSTA,1
#define	RX9D	RCSTA,0
;----- CCP2CON Bits -------------------------------------------------------
#define	CCP2X	CCP2CON,5
#define	CCP2Y	CCP2CON,4
#define	CCP2M3	CCP2CON,3
#define	CCP2M2	CCP2CON,2
#define	CCP2M1	CCP2CON,1
#define	CCP2M0	CCP2CON,0
;----- ADCON0 Bits --------------------------------------------------------
#define	ADCS1	ADCON0,7
#define	ADCS0	ADCON0,6
#define	CHS2	ADCON0,5
#define	CHS1	ADCON0,4
#define	CHS0	ADCON0,3
#define	GO	ADCON0,2
#define	ADON	ADCON0,0
;----- OPTION_REG Bits ----------------------------------------------------
#define	RBPU	OPTION_REG,7
#define	INTEDG	OPTION_REG,6
#define	T0CS	OPTION_REG,5
#define	T0SE	OPTION_REG,4
#define	PSA	OPTION_REG,3
#define	PS2	OPTION_REG,2
#define	PS1	OPTION_REG,1
#define	PS0	OPTION_REG,0
;----- PIE1 Bits ----------------------------------------------------------
#define	ADIE	PIE1,6
#define	RCIE	PIE1,5
#define	TXIE	PIE1,4
#define	SSPIE	PIE1,3
#define	CCP1IE	PIE1,2
#define	TMR2IE	PIE1,1
#define	TMR1IE	PIE1,0
;----- PIE2 Bits ----------------------------------------------------------
#define	EEIE	PIE2,4
#define	BCLIE	PIE2,3
#define	CCP2IE	PIE2,0
;----- PCON Bits ----------------------------------------------------------
#define	POR	PCON,1
#define	BOR	PCON,0
;----- SSPCON2 Bits --------------------------------------------------------
;----- SSPSTAT Bits -------------------------------------------------------
;----- TXSTA Bits ---------------------------------------------------------
#define	CSRC	TXSTA,7
#define	TX9	TXSTA,6
#define	TXEN	TXSTA,5
#define	SYNC	TXSTA,4
#define	BRGH	TXSTA,2
#define	TRMT	TXSTA,1
#define	TX9D	TXSTA,0
;----- ADCON1 Bits --------------------------------------------------------
#define	ADFM	ADCON1,7
#define	PCFG3	ADCON1,3
#define	PCFG2	ADCON1,2
#define	PCFG1	ADCON1,1
#define	PCFG0	ADCON1,0
;----- EECON1 Bits --------------------------------------------------------
#define	EEPGD	EECON1,7
#define	WRERR	EECON1,3
#define	WREN	EECON1,2
#define	WR	EECON1,1
#define	RD	EECON1,0
;--------------------------------------------------------------------------
        LIST
