;------------------------------------------------------------------
; update all time counters except analog seconds
;------------------------------------------------------------------
;keep seconds
keep_time
	incf	secu,F
	movf	secu,W
	sublw	10
	btfss	Z
	return
	clrf	secu
	incf	secd,F
	movf	secd,W
	sublw	6
	btfss	Z
	return
	clrf	secd
	clrf	s_hand
;keep minutes
	movlw	4		;increase minutes hand
	addwf	m_hand,F
	btfsc	minu,0		;even number of minutes?
	bsf	SCRL		;yes, activate scroller
min_ct	incf	minu,F
	movf	minu,W
	sublw	10
	btfss	Z
	return
	clrf	minu
	incf	mind,F
	movf	mind,W
	sublw	6
	btfss	Z
	return
	clrf	mind
	clrf	m_hand
;keep hours
	movlw	20		;increase hours hand
	addwf	h_hand,F
	movf	h_hand,W
	sublw	240		;12 hours?
	btfsc	Z
	clrf	h_hand		;yes, clear
	incf	hoursu,F
	movf	hoursu,W
	sublw	10
	btfss	Z
	goto	hourhex
	clrf	hoursu
	incf	hoursd,F
hourhex	incf	hours,F
	movf	hours,W
	sublw	24
	btfss	Z
	return
	clrf	hoursu
	clrf	hoursd
	clrf	hours
;keep weekday
	bsf	DAY
	incf	day,F
	movf	day,W
	sublw	7
	btfsc	Z
	clrf	day
;keep date
	incf	dateu,F
	movf	dateu,W
	sublw	10
	btfss	Z
	goto	datehex
	clrf	dateu
	incf	dated,F
datehex	decfsz	date,F
	return
	movlw	1
	movwf	dateu
	clrf	dated
;keep month and reload date
	incf	month,F
	movf	month,W
	sublw	12
	btfss	Z
	goto	endupm
	clrf	month
	incf	year,F
endupm	movlw	high days_per_month
	movwf	PCLATH
	movf	month,W
	call	days_per_month
	movwf	date
	return
;------------------------------------------------------------------
; prepare time buffer (line0)
;------------------------------------------------------------------
buffer_time
	movf	hoursd,W
	addlw	30
	movwf	l0tbuf
	movf	hoursu,W
	addlw	30
	movwf	l0tbuf+1
	movf	mind,W
	addlw	30
	movwf	l0tbuf+3
	movf	minu,W
	addlw	30
	movwf	l0tbuf+4
	movf	secd,W
	addlw	30
	movwf	l0tbuf+6
	movf	secu,W
	addlw	30
	movwf	l0tbuf+7
	return
;------------------------------------------------------------------
; prepare date buffer (lines 1-3)
;------------------------------------------------------------------
buffer_date
;clear buffers
	movlw	l1tbuf
	movwf	FSR		;load W into FSR
clearbf	clrf	INDF		;clear indirect RAM address
	incf	FSR,F
	movf	FSR,W
	sublw	l3tbuf		;last location? (=first loc of year)
	btfss	Z
	goto	clearbf		;no, repeat
;weekday
	movlw	high weekday_names
	movwf	PCLATH
	movlw	l1tbuf		;initialize buffer pointer
	movwf	FSR
	movf	day,W		;day number
	call	weekday_names	;get day_name offset
	movwf	a_temp		;put into offset counter
bdrpt	movf	a_temp,W	;get offset counter
	call	weekday_names	;get day_name character
	movwf	b_temp
	andlw	B'00011111'	;filter
	movwf	INDF		;put into text buffer
	btfsc	b_temp,5	;lower case? (last char?)
	goto	b_dag		;yes, ready
	incf	a_temp,F	;increment counter
	incf	FSR,F		;increment pointer
	goto	bdrpt		; and repeat
b_dag	incf	FSR,F
	movlw	4		;"D"
	movwf	INDF
	incf	FSR,F
	movlw	1		;"A"
	movwf	INDF
	incf	FSR,F
	movlw	7		;"G"
	movwf	INDF
;date
	movlw	l2tbuf
	movwf	FSR		;init buffer pointer
	movf	dated,W		;date decades
	btfsc	Z		;blank 0?
	goto	dt_blnk		;yes
	addlw	30		;no, add offset
	movwf	INDF		;put into buffer
	incf	FSR,F		;increment buffer pointer
dt_blnk	movf	dateu,W		;date units
	addlw	30
	movwf	INDF
	incf	FSR,F
	clrw			;<space>
	movwf	INDF
	incf	FSR,F	
;month
	movf	month,W		;month number
	call	month_names	;get day_name offset
	movwf	a_temp		;put into offset counter
mdrpt	movf	a_temp,W	;get offset counter
	call	month_names	;get day_name character
	movwf	b_temp
	andlw	B'00011111'	;filter
	movwf	INDF		;put into text buffer
	btfsc	b_temp,5	;lower case? (last char?)
	goto	b_year		;yes, ready
	incf	a_temp,F	;increment counter
	incf	FSR,F		;increment pointer
	goto	mdrpt		; and repeat
;year
b_year	movf	year,W
	addlw	30
	movwf	l3tbuf+3
	return
;------------------------------------------------------------------
; update scroller
;------------------------------------------------------------------
update_scroller
	decfsz	year_start,F	;rotate year display
	goto	sc_cu
	movlw	240
	movwf	year_start
sc_cu	decf	scroll,F	;point to next buffer location
	btfss	scroll,7	;underflow?
	goto	sc_ct
	movlw	95
	movwf	scroll
sc_ct	btfsc	SC_SPC		;character spacing?
	goto	spacing		;yes
	movlw	high scroll_text
	movwf	PCLATH
	movf	sctcnt,W	;get text counter
	call	scroll_text	;get character
	movwf	e_temp		;store
	btfsc	e_temp,7	;last character? (128?)
	goto	sc_end		;yes, end this right now
	movlw	high chars
	movwf	PCLATH
	movf	e_temp,W
	call	chars		;get character address offset
	addwf	sctscan,W	;add scan line offset
	call	chars		;get character bit pattern
	movwf	e_temp		;put in buffer
	btfss	e_temp,7	;last pattern bit set?
	goto	next_d		;no, next pattern
	bcf	e_temp,7	;yes, clear bit from buffer
	incf	sctcnt,F	;increase char counter
	movlw	255
	movwf	sctscan		;reset scan line counter
	bsf	SC_SPC		;next update will be char spacing
next_d	incf	sctscan,F	;incement scan line counter
next_l	movf	scroll,W	;get circular buffer position
	addlw	H'10'		;add offset (due to 16 SFRs in page 2)
	movwf	FSR		;put into pointer
	call	reverse		;reverse bits
	bsf	IRP
	movwf	INDF		;put into place
	bcf	IRP
	return
spacing	clrf	e_temp
	bcf	SC_SPC
	goto	next_l
sc_end	bcf	SCRL		;end scroller, back to logo
	movlw	230
	movwf	year_start	;reset year position
	clrf	sscan		;reset buffer scan
	clrf	sctcnt		;reset scroller text pointer
	clrf	sctscan		;reset character scan
	clrf	gmem		;reset logo memory pointer
				; SCRL bit may have been set during
				; display of logo
	movlw	64		;make sure logo doesn't synchronize
	movwf	gscan		; until its starting frame
	return	
;------------------------------------------------------------------
; write to bus
;------------------------------------------------------------------
wrbus	movf	l0pbuf,W	;get line 0 port buffer
	movwf	PORTB		;move to port B
	bsf	A0		;enable latch 0
	movf	l1pbuf,W	;get line 1 port buffer
	bcf	A0		;disable latch 0
	movwf	PORTB		;move to port B
	bsf	A1		;enable latch 1
	movf	l2pbuf,W	;get line 2 port buffer
	bcf	A1		;disable latch 1
	movwf	PORTB		;move to port B
	bsf	A2		;enable latch 2
	movf	l3pbuf,W	;get line 3 port buffer
	bcf	A2		;disable latch 2
	movwf	PORTB		;move to port B
	bsf	A3		;enable latch 3
	bcf	A3		;disable latch 3
	bcf	YL2
	bcf	YL3
	return
;------------------------------------------------------------------
;set time
;0  1  2  3  4  5  6  7  0  1  2  3
;YR MD MU DD DU WK HD HU MD MU SD SU
;------------------------------------------------------------------
settime	clrf	c_temp		;setting nr index
	clrf	d_temp		;setting
	movlw	year		;set pointer to first setting
	movwf	FSR
setrpt	movf	c_temp,W
	call	setled		;turn on led
adjrpt	movf	d_temp,W
	iorlw	B'00010000'	;turn on setting
	call	setled
rlsekey	btfsc	SEL
	goto	rlsekey
	btfsc	ADJ
	goto	rlsekey
waitadj	btfss	ADJ
	goto	waitsel
	incf	d_temp,F	;increase temp setting
	movf	d_temp,W
	sublw	10		;setting >9?
	btfsc	Z
	clrf	d_temp		;yes, return to zero
	goto	adjrpt		;continue
waitsel	btfss	SEL
	goto	waitadj
	incf	c_temp,F	;increase setting number
	movf	c_temp,W
	sublw	12		;done all 12 settings?
	btfsc	Z		;no, continue
	return			;yes, done
	movf	d_temp,W	;get temp setting
	movwf	INDF		;store setting
	incf	FSR,F		;increase memory pointer
	clrf	d_temp		;new setting equals 0
	goto	setrpt		;repeat
;------------------------------------------------------------------
; convert BCD time settings to internal counters
;------------------------------------------------------------------
bcdtime
;set hex month counter
	movf	monthd,W	;get decades
	btfss	Z		;decade digit=0
	movlw	10		;no, load 10
	addwf	monthu,W	;yes, just add units
	addlw	-1		;correct 0-11/1-12 issue
	movwf	month
;set hex date counter
	call	endupm		;date has max date
	movf	dated,W
	call	mul_10
	addwf	dateu,W		;W has input number
	addlw	-1
	subwf	date,F		;datehex=datemax-inputdate
;set weekday counter
	decf	day,F		;correct 0-6/1-7 issue
;set hex hours counter
	movf	hoursd,W	;get decades
	call	mul_10		;multiply by 10
	addwf	hoursu,W	;add units
	movwf	hours		;store result
;set hour hand position
	bcf	C
	rlf	hours,W		;get 2*hours
	movwf	a_temp		;store
	addlw	-24		;subtract 24
	btfss	C		;overflow?
	movf	a_temp,W	;no, reload
	call	mul_10		;yes, value is ok
	movwf	h_hand
;set minutes hand position
	movf	mind,W
	call	mul_10
	addwf	minu,W
	movwf	b_temp
	rlf	b_temp,F
	rlf	b_temp,W
	movwf	m_hand
;set seconds hand position
	movf	secd,W
	call	mul_10
	addwf	secu,W
	movwf	b_temp
	rlf	b_temp,F
	rlf	b_temp,W
	movwf	s_hand
	return
mul_10	movwf	a_temp		; multiply W by 10
	bcf	C		;clear carry
	rlf	a_temp,F	;temp=temp*2	*2
	rlf	a_temp,F	;temp=temp*2	*4
	addwf	a_temp,F	;temp=temp+W	*5
	rlf	a_temp,W	;W=temp*2	*10
	return
;------------------------------------------------------------------
; set 1 LED
; digit 0-15 / setting 16-31
;------------------------------------------------------------------
setled	movwf	a_temp		;store LED nr
	andlw	B'00000111'	;get 3 LSBits
	addlw	1		;add 1
	movwf	b_temp		;put into shift counter
	clrf	e_temp		;clear PORTB buffer
	clrf	PORTB		;clear PORTB
	bsf	C		;set carry
setlp	rlf	e_temp,F	;rotate (carry into) bus
	decfsz	b_temp,F	;shift counter underflow?
	goto	setlp		;no, repeat
setgt	btfsc	a_temp,4	;digit or setting?
	goto	setgts		;->setting
	movlw	B'0011'		;clear leds 0-15
	movwf	PORTA
	clrf	PORTA
	movf	e_temp,W
	movwf	PORTB
	btfss	a_temp,3	;LED 8 or 9?
	bsf	A0
	btfsc	a_temp,3
	bsf	A1
	goto	setend
setgts	movlw	B'1100'		;clear leds 16-31
	movwf	PORTA
	clrf	PORTA
	movf	e_temp,W
	movwf	PORTB
	btfss	a_temp,3	;LED 8 or 9?
	bsf	A2
	btfsc	a_temp,3
	bsf	A3
setend	clrf	PORTA		;disable buffers
	return
;------------------------------------------------------------------
; adjust crystal (put 1200 Hz on Yellow led 1)
;------------------------------------------------------------------
adjust	movlw	11		;set timer 2 period (1200 Hz)
	bsf	RP0		;bank 1
	movwf	PR2
	bsf	D0		;bus input
	bcf	RP0		;bank 0
	bsf	A1		;put clock pulse on led
adjlp	btfss	TMR2,3
	bcf	YL1
	btfsc	TMR2,3
	bsf	YL1
	btfss	SEL		;Sel button pressed?
	goto	adjlp		;no, loop
	bcf	YL1		;yes
	movlw	239		;set timer 2 period (60 Hz)
	bsf	RP0		;bank 1
	movwf	PR2
	bcf	D0		;bus output
	bcf	RP0		;bank 0
	call	wait		;wait .25s
unpress	btfsc	SEL
	goto	unpress		;wait for release of button
	return
;------------------------------------------------------------------
; all LEDs off
;------------------------------------------------------------------
alloff	clrf	PORTB		;all zeros
	movlw	B'1111'		;gate all buffers
	clrf	PORTC		;yellow leds off
	movwf	PORTA
	clrf	PORTA		;disable all buffers
	return
;------------------------------------------------------------------
; LED test
;------------------------------------------------------------------
ledtest	bsf	YL1
	call	wait
	bcf	YL1
	bsf	A0
	movlw	4
	movwf	a_temp
test_1	movlw	1
	movwf	PORTB
test_2	call	wait
	bcf	C
	rlf	PORTB,F
	btfss	C
	goto	test_2
	bcf	C
	rlf	PORTA,F
	decfsz	a_temp,F
	goto	test_1
	bsf	YL2
	call	wait
	bcf	YL2
	bsf	YL3
	call	wait
	bcf	YL3
	return
;------------------------------------------------------------------
; wait for 15 timer2 time-outs (0.25 sec)
;------------------------------------------------------------------
wait	movlw	15
	movwf	pre1
wait_1	btfss	TMR2IF
	goto	wait_1
	bcf	TMR2IF
	decfsz	pre1,F
	goto	wait_1
	return
;------------------------------------------------------------------
; clear memory from W to top of memory
;------------------------------------------------------------------
clrmem	movwf	FSR		;load W into FSR
clear	clrf	INDF		;clear indirect RAM address
	incf	FSR,F
	movf	FSR,W
	andlw	B'01111111'	;discard bit 7
	sublw	H'7F'		;last location?
	btfss	Z
	goto	clear		;no, repeat
	return			;yes, return
;------------------------------------------------------------------
; read lookup table anywhere in memory
;------------------------------------------------------------------
;lookup	movf	indexmsb,W
;	addlw	high table
;	movwf	PCLATH
;	movlw	low table
;	addwf	indexlsb,W
;	btfsc	C
;	incf	PCLATH,F
;	movwf	PCL
;------------------------------------------------------------------
; reverse bit order e_temp into W
;------------------------------------------------------------------
reverse	clrf	d_temp
	rrf	e_temp,F	;6543210->C
	rlf	d_temp,F	;C->0123456
	rrf	e_temp,F
	rlf	d_temp,F
	rrf	e_temp,F
	rlf	d_temp,F
	rrf	e_temp,F
	rlf	d_temp,F
	rrf	e_temp,F
	rlf	d_temp,F
	rrf	e_temp,F
	rlf	d_temp,F
	rrf	e_temp,F
	rlf	d_temp,W	;result into W
	return
;------------------------------------------------------------------
