;		__________
;RESET	MCLR	1  U	28	RB7	D7
;EN0	RA0	2	27	RB6	D6
;EN1	RA1	3	26	RB5	D5
;EN2	RA2	4	25	RB4	D4
;EN3	RA3	5	24	RB3	D3
;-	RA4	6	23	RB2	D2
;INDEX	RA5	7	22	RB1	D1
;GNG	GND	8	21	RB0	D0/frame
;Xtal	OSC1	9	20	V+	+5V
;Xtal	OSC2	10	19	GND	GND
;YL1	RC0	11	18	RC7	-
;YL2	RC1	12	17	RC6	-
;YL3	RC2	13	16	RC5	ADJ
;MOTOR	RC3	14______15	RC4	SEL
;
;------------------------------------------------------------------
; DEFINE PINOUT
;------------------------------------------------------------------
#define	A0	PORTA,0	;AN0		OUT	LED bank 0 		*
#define A1	PORTA,1	;AN1		OUT	LED bank 1		*
#define A2	PORTA,2	;AN2/Vref-	OUT	LED bank 2		*
#define	A3	PORTA,3	;AN3/Vref+	OUT	LED bank 3		*
#define RA4	PORTA,4	;T0CKI		OUT				-
#define INDEX	PORTA,5	;AN4/-SS	IN	index in		*
					
#define D7	PORTB,7	;PGD		OUT	D7 databus		*
#define D6	PORTB,6	;PGC		OUT	D6 databus		*
#define D5	PORTB,5	;		OUT	D5 databus		*
#define D4	PORTB,4	;		OUT	D4 databus		*
#define D3	PORTB,3	;PGM		OUT	D3 databus		*
#define D2	PORTB,2	;		OUT	D2 databus		*
#define D1	PORTB,1	;		OUT	D1 databus		*
#define D0	PORTB,0	;INT		OUT/IN	D0 databus / frame	*/*
				
#define YL1	PORTC,0	;T1OSO/T1CKI	OUT	Yellow led 1/Xtal adj	*
#define	YL2	PORTC,1	;T1OSI/CCP2	OUT	Yellow led 2		*
#define YL3	PORTC,2	;CCP1		OUT	Yellow led 3		*
#define MOTOR	PORTC,3	;SCK/SCL	OUT	motor on		*
#define SEL	PORTC,4	;SDI/SDA	IN	Select button		*
#define ADJ	PORTC,5	;SDO		IN	Adjust button		*
#define	TX	PORTC,6	;TX/CK		OUT				-
#define	RX	PORTC,7	;RX/DT		OUT				-
;------------------------------------------------------------------
; RAM REGISTERS
;------------------------------------------------------------------
	cblock	H'0020'
s_hand		;position of seconds hand
m_hand		;position of minutes hand
h_hand		;position of hours hand
hours		;hours hex
date		;date hex	DOWNCOUNTER (months per day table)
month		;month hex
year		;year -2000
monthd		;month decades (only used for setting the time)
monthu		;month units (only used for setting the time)
dated		;date decades
dateu		;date units
day		;week day
hoursd		;hours decades
hoursu		;hours units
mind		;minutes decades
minu		;minutes units
secd		;seconds decades
secu		;seconds units
logo		;logo nr
gscan		;graphic scanline counter
gmem		;graphic memory counter
sscan		;scroller scanline counter
scroll		;scroller position counter
sctcnt		;scroller text pointer
sctscan		;scroller text character scan
l0pbuf		;LED line 0 port buffer
l1pbuf		;LED line 1 port buffer
l2pbuf		;LED line 2 port buffer
l3pbuf		;LED line 3 port buffer
l0cnt		;Line 0 character counter
l1cnt		;Line 1 character counter
l2cnt		;Line 2 character counter
l3cnt		;Line 3 character counter
l0scan		;Line 0 character scan line counter
l1scan		;Line 1 character scan line counter
l2scan		;Line 2 character scan line counter
l3scan		;Line 3 character scan line counter
l0tbuf:8	;12:34:56
l1tbuf:9	;DONDERDAG
l2tbuf:12	;22 SEPTEMBER
l3tbuf:4	;2001
time_start	;starting frame of time display
day_start
date_start
year_start
graph_start	;starting frame of logo display
	endc
	cblock	H'0070'
s_temp		;STATUS temp			(mirrored)
w_temp		;W temp				(mirrored)
p_temp		;PCLATH temp			(mirrored)
a_temp
b_temp
c_temp
d_temp
e_temp
dot		;dot counter (0-239)
hourdot		;hour dots (0-19)
fr		;flag register
fr2		;2nd flag register
pre1		;.25 sec prescaler (60Hz/15)
pre2		;1 sec prescaler (4Hz/4)
	endc
;		fr,0-3	;character spacing passbits
#define	ZERO	fr,4	;frame reset bit
#define	PHASE	fr,5	;frame rate divider
#define	DAY	fr,6	;date roll pass bit
#define	SCRL	fr,7	;change to scrolling message every 2 minutes
#define	SC_SPC	fr2,0	;scroller character spacing
